/*
 * This file is part of the Owl Positioning System (OwlPS) project.
 * It is subject to the copyright notice and license terms in the
 * COPYRIGHT.t2t file found in the top-level directory of this
 * distribution and at
 *   https://code.lm7.fr/mcy/owlps/src/master/COPYRIGHT.t2t
 * No part of the OwlPS Project, including this file, may be copied,
 * modified, propagated, or distributed except according to the terms
 * contained in the COPYRIGHT.t2t file; the COPYRIGHT.t2t file must be
 * distributed along with this file, either separately or by replacing
 * this notice by the COPYRIGHT.t2t file's contents.
 */


#ifndef _OWLPS_POSITIONING_INPUTDATAREADER_HH_
#define _OWLPS_POSITIONING_INPUTDATAREADER_HH_

class InputMedium ;
class CalibrationRequest ;

#include <vector>

/// Reads input data using parameters in Configuration
class InputDataReader
{
protected:
  std::vector<InputMedium*> reference_points_media ;

  void read_access_points(void) ;
  void initialise_access_points_media(void) ;
  void initialise_access_points_csv(void) ;

  void read_mobiles(void) ;
  void initialise_mobiles_media(void) ;
  void initialise_mobiles_csv(void) ;

  void read_topology(void) ;
  void initialise_topology_media(void) ;
  void initialise_topology_csv(void) ;

  void read_reference_points(void) ;
  void initialise_reference_points_media(void) ;
  void initialise_reference_points_csv(void) ;
  void read_from_reference_points_media(void) ;

public:
  InputDataReader(void) ;

  ~InputDataReader(void) ;
} ;

#endif // _OWLPS_POSITIONING_INPUTDATAREADER_HH_
